diff -ur mpd-5.6/src/iface.c mpd-5.6-lutz/src/iface.c
--- mpd-5.6/src/iface.c	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/iface.c	2013-04-24 23:10:19.000000000 +0200
@@ -1281,10 +1281,12 @@
 	if (iface->dodCache.ts + MAX_DOD_CACHE_DELAY < time(NULL))
     	    mbfree(iface->dodCache.pkt);
 	else {
+	    MUTEX_LOCK(gNgMutex);
     	    if (NgFuncWritePppFrame(b, NG_PPP_BUNDLE_LINKNUM,
 		    iface->dodCache.proto, iface->dodCache.pkt) < 0) {
 		Perror("[%s] can't write cached pkt", b->name);
     	    }
+	    MUTEX_UNLOCK(gNgMutex);
 	}
 	iface->dodCache.pkt = NULL;
     }
@@ -1846,7 +1848,7 @@
     int s;
     char buf[48], buf1[48];
 
-    Log(LG_IFACE2, ("[%s] IFACE: %s address %s->%s %s %s",
+    Log(LG_IFACE, ("[%s] IFACE: %s address %s->%s %s %s",
 	b->name, add?"Add":"Remove", u_rangetoa(self, buf, sizeof(buf)), 
 	((peer != NULL)?u_addrtoa(peer, buf1, sizeof(buf1)):""),
 	add?"to":"from", b->iface.ifname));
@@ -1902,7 +1904,7 @@
 
 	res = ioctl(s, add?SIOCAIFADDR_IN6:SIOCDIFADDR_IN6, &ifra6);
 	if (res == -1) {
-	    Perror("[%s] IFACE: %s IPv6 address %s %s failed", 
+	    Perror("[%s] IFACE: %s IPv6 address %s %s failed",
 		b->name, add?"Adding":"Removing", add?"to":"from", b->iface.ifname);
 	}
 	break;
@@ -1987,8 +1989,13 @@
 
     nb = cp - (char *)&rtmes;
     rtmes.m_rtm.rtm_msglen = nb;
+retry_route:
     wb = write(s, &rtmes, nb);
     if (wb < 0) {
+        if(rtmes.m_rtm.rtm_type == RTM_ADD) {
+	   rtmes.m_rtm.rtm_type = RTM_CHANGE;
+	   goto retry_route;
+	}
     	Log(LG_ERR, ("[%s] IFACE: %s route %s %s failed: %s",
 	    b->name, cmdstr, u_rangetoa(dst, buf, sizeof(buf)), 
 	    ((gw != NULL)?u_addrtoa(gw, buf1, sizeof(buf1)):""),
@@ -2149,12 +2156,15 @@
     strcpy(cn.ourhook, hook);
     snprintf(cn.path, sizeof(cn.path), "%s:", b->iface.ngname);
     strcpy(cn.peerhook, NG_IFACE_HOOK_INET);
+    MUTEX_LOCK(gNgMutex);
     if (NgSendMsg(gLinksCsock, path,
     	    NGM_GENERIC_COOKIE, NGM_CONNECT, &cn, sizeof(cn)) < 0) {
 	Perror("[%s] can't connect \"%s\"->\"%s\" and \"%s\"->\"%s\"",
 	    b->name, path, cn.ourhook, cn.path, cn.peerhook);
+	MUTEX_UNLOCK(gNgMutex);
 	goto fail;
     }
+    MUTEX_UNLOCK(gNgMutex);
 
     if (ready) {
 #ifdef USE_NG_NETFLOW
@@ -2233,11 +2243,13 @@
 #endif
     b->iface.mss_up = 0;
 
+    MUTEX_LOCK(gNgMutex);
     snprintf(path, sizeof(path), "[%x]:", b->nodeID);
     NgFuncDisconnect(gLinksCsock, b->name, path, NG_PPP_HOOK_INET);
 
     snprintf(path, sizeof(path), "%s:", b->iface.ngname);
     NgFuncDisconnect(gLinksCsock, b->name, path, NG_IFACE_HOOK_INET);
+    MUTEX_UNLOCK(gNgMutex);
 }
 
 static int
@@ -2265,6 +2277,7 @@
   
     }
 
+    MUTEX_LOCK(gNgMutex);
     /* Connect graph to the iface node. */
     strcpy(cn.ourhook, hook);
     snprintf(cn.path, sizeof(cn.path), "%s:", b->iface.ngname);
@@ -2273,8 +2286,10 @@
     	    NGM_GENERIC_COOKIE, NGM_CONNECT, &cn, sizeof(cn)) < 0) {
 	Perror("[%s] can't connect \"%s\"->\"%s\" and \"%s\"->\"%s\"",
 	    b->name, path, cn.ourhook, cn.path, cn.peerhook);
+	MUTEX_UNLOCK(gNgMutex);
 	goto fail;
     }
+    MUTEX_UNLOCK(gNgMutex);
 
     /* OK */
     return(0);
@@ -2296,11 +2311,13 @@
 	IfaceShutdownTee(b, 1);
     b->iface.tee6_up = 0;
 
+    MUTEX_LOCK(gNgMutex);
     snprintf(path, sizeof(path), "[%x]:", b->nodeID);
     NgFuncDisconnect(gLinksCsock, b->name, path, NG_PPP_HOOK_IPV6);
 
     snprintf(path, sizeof(path), "%s:", b->iface.ngname);
     NgFuncDisconnect(gLinksCsock, b->name, path, NG_IFACE_HOOK_INET6);
+    MUTEX_UNLOCK(gNgMutex);
 }
 
 #ifdef USE_NG_NAT
@@ -2314,6 +2331,7 @@
 #ifdef NG_NAT_LOG
     struct ng_nat_mode	mode;
 #endif  
+    MUTEX_LOCK(gNgMutex);
     Log(LG_IFACE2, ("[%s] IFACE: Connecting NAT", b->name));
   
     strcpy(mp.type, NG_NAT_NODE_TYPE);
@@ -2323,6 +2341,7 @@
 	NGM_GENERIC_COOKIE, NGM_MKPEER, &mp, sizeof(mp)) < 0) {
       Perror("[%s] can't create %s node at \"%s\"->\"%s\"",
 	b->name, NG_NAT_NODE_TYPE, path, mp.ourhook);
+      MUTEX_UNLOCK(gNgMutex);
       return(-1);
     }
     strlcat(path, ".", NG_PATHSIZ);
@@ -2331,6 +2350,7 @@
     if (NgSendMsg(gLinksCsock, path,
 	NGM_GENERIC_COOKIE, NGM_NAME, &nm, sizeof(nm)) < 0) {
       Perror("[%s] can't name %s node", b->name, NG_NAT_NODE_TYPE);
+      MUTEX_UNLOCK(gNgMutex);
       return(-1);
     }
     strcpy(hook, NG_NAT_HOOK_OUT);
@@ -2373,6 +2393,7 @@
     }
 #endif
 
+    MUTEX_UNLOCK(gNgMutex);
     return(0);
 }
 
@@ -2383,6 +2404,7 @@
     char	path[NG_PATHSIZ];
     int k;
 
+    MUTEX_LOCK(gNgMutex);
     if (u_addrempty(&nat->alias_addr)) {
 	snprintf(path, sizeof(path), "mpd%d-%s-nat:", gPid, b->name);
 	if (NgSendMsg(gLinksCsock, path,
@@ -2390,6 +2412,7 @@
 		&b->iface.self_addr.addr.u.ip4,
 		sizeof(b->iface.self_addr.addr.u.ip4)) < 0) {
 	    Perror("[%s] can't set NAT ip", b->name);
+	    MUTEX_UNLOCK(gNgMutex);
 	    return (-1);
 	}
     }
@@ -2425,6 +2448,7 @@
       }
     }
 #endif
+    MUTEX_UNLOCK(gNgMutex);
     return (0);
 }
 
@@ -2434,7 +2458,9 @@
     char	path[NG_PATHSIZ];
 
     snprintf(path, sizeof(path), "mpd%d-%s-nat:", gPid, b->name);
+    MUTEX_LOCK(gNgMutex);
     NgFuncShutdownNode(gLinksCsock, b->name, path);
+    MUTEX_UNLOCK(gNgMutex);
 }
 #endif /* USE_NG_NAT */
 
@@ -2444,6 +2470,7 @@
     struct ngm_mkpeer	mp;
     struct ngm_name	nm;
 
+    MUTEX_LOCK(gNgMutex);
     Log(LG_IFACE2, ("[%s] IFACE: Connecting tee%s", b->name, v6?"6":""));
   
     strcpy(mp.type, NG_TEE_NODE_TYPE);
@@ -2453,6 +2480,7 @@
 	NGM_GENERIC_COOKIE, NGM_MKPEER, &mp, sizeof(mp)) < 0) {
       Perror("[%s] can't create %s node at \"%s\"->\"%s\"",
 	b->name, NG_TEE_NODE_TYPE, path, mp.ourhook);
+      MUTEX_UNLOCK(gNgMutex);
       return(-1);
     }
     strlcat(path, ".", NG_PATHSIZ);
@@ -2461,10 +2489,12 @@
     if (NgSendMsg(gLinksCsock, path,
 	NGM_GENERIC_COOKIE, NGM_NAME, &nm, sizeof(nm)) < 0) {
       Perror("[%s] can't name %s node", b->name, NG_TEE_NODE_TYPE);
+      MUTEX_UNLOCK(gNgMutex);
       return(-1);
     }
     strcpy(hook, NG_TEE_HOOK_LEFT);
 
+    MUTEX_UNLOCK(gNgMutex);
     return(0);
 }
 
@@ -2473,8 +2503,10 @@
 {
     char	path[NG_PATHSIZ];
 
+    MUTEX_LOCK(gNgMutex);
     snprintf(path, sizeof(path), "%s-tee%s:", b->iface.ifname, v6?"6":"");
     NgFuncShutdownNode(gLinksCsock, b->name, path);
+    MUTEX_UNLOCK(gNgMutex);
 }
 
 #ifdef USE_NG_IPACCT
@@ -2490,6 +2522,7 @@
 	int		data;
     } ipam;
 
+    MUTEX_LOCK(gNgMutex);
     Log(LG_IFACE2, ("[%s] IFACE: Connecting ipacct", b->name));
   
     strcpy(mp.type, NG_TEE_NODE_TYPE);
@@ -2499,6 +2532,7 @@
 	NGM_GENERIC_COOKIE, NGM_MKPEER, &mp, sizeof(mp)) < 0) {
       Perror("[%s] can't create %s node at \"%s\"->\"%s\"",
 	b->name, NG_TEE_NODE_TYPE, path, mp.ourhook);
+      MUTEX_UNLOCK(gNgMutex);
       return(-1);
     }
     strlcat(path, ".", NG_PATHSIZ);
@@ -2507,6 +2541,7 @@
     if (NgSendMsg(gLinksCsock, path,
 	NGM_GENERIC_COOKIE, NGM_NAME, &nm, sizeof(nm)) < 0) {
       Perror("[%s] can't name %s node", b->name, NG_TEE_NODE_TYPE);
+      MUTEX_UNLOCK(gNgMutex);
       return(-1);
     }
     strcpy(hook, NG_TEE_HOOK_LEFT);
@@ -2518,6 +2553,7 @@
 	NGM_GENERIC_COOKIE, NGM_MKPEER, &mp, sizeof(mp)) < 0) {
       Perror("[%s] can't create %s node at \"%s\"->\"%s\"",
 	b->name, NG_IPACCT_NODE_TYPE, path, mp.ourhook);
+      MUTEX_UNLOCK(gNgMutex);
       return(-1);
     }
     snprintf(path1, sizeof(path1), "%s.%s", path, NG_TEE_HOOK_RIGHT2LEFT);
@@ -2525,6 +2561,7 @@
     if (NgSendMsg(gLinksCsock, path1,
 	NGM_GENERIC_COOKIE, NGM_NAME, &nm, sizeof(nm)) < 0) {
       Perror("[%s] can't name %s node", b->name, NG_IPACCT_NODE_TYPE);
+      MUTEX_UNLOCK(gNgMutex);
       return(-1);
     }
     strcpy(cn.ourhook, NG_TEE_HOOK_LEFT2RIGHT);
@@ -2534,6 +2571,7 @@
 	sizeof(cn)) < 0) {
       Perror("[%s] can't connect \"%s\"->\"%s\" and \"%s\"->\"%s\"",
         b->name, path, cn.ourhook, cn.path, cn.peerhook);
+      MUTEX_UNLOCK(gNgMutex);
       return (-1);
     }
     
@@ -2542,12 +2580,14 @@
     if (NgSendMsg(gLinksCsock, path1, NGM_IPACCT_COOKIE, NGM_IPACCT_SETDLT, 
 	&ipam, sizeof(ipam)) < 0) {
       Perror("[%s] can't set DLT \"%s\"->\"%s\"", b->name, path, ipam.m.hname);
+      MUTEX_UNLOCK(gNgMutex);
       return (-1);
     }
     ipam.data = 10000;
     if (NgSendMsg(gLinksCsock, path1, NGM_IPACCT_COOKIE, NGM_IPACCT_STHRS, 
 	&ipam, sizeof(ipam)) < 0) {
       Perror("[%s] can't set DLT \"%s\"->\"%s\"", b->name, path, ipam.m.hname);
+      MUTEX_UNLOCK(gNgMutex);
       return (-1);
     }
     
@@ -2556,15 +2596,18 @@
     if (NgSendMsg(gLinksCsock, path1, NGM_IPACCT_COOKIE, NGM_IPACCT_SETDLT, 
 	&ipam, sizeof(ipam)) < 0) {
       Perror("[%s] can't set DLT \"%s\"->\"%s\"", b->name, path, ipam.m.hname);
+      MUTEX_UNLOCK(gNgMutex);
       return (-1);
     }
     ipam.data = 10000;
     if (NgSendMsg(gLinksCsock, path1, NGM_IPACCT_COOKIE, NGM_IPACCT_STHRS, 
 	&ipam, sizeof(ipam)) < 0) {
       Perror("[%s] can't set DLT \"%s\"->\"%s\"", b->name, path, ipam.m.hname);
+      MUTEX_UNLOCK(gNgMutex);
       return (-1);
     }
 
+    MUTEX_UNLOCK(gNgMutex);
     return(0);
 }
 
@@ -2573,8 +2616,10 @@
 {
     char	path[NG_PATHSIZ];
 
+    MUTEX_LOCK(gNgMutex);
     snprintf(path, sizeof(path), "%s_acct_tee:", b->iface.ifname);
     NgFuncShutdownNode(gLinksCsock, b->name, path);
+    MUTEX_UNLOCK(gNgMutex);
 }
 #endif
 
@@ -2591,12 +2636,15 @@
     nif = gNetflowIface + b->id*2 + out;
 #endif
 
+    MUTEX_LOCK(gNgMutex);
     Log(LG_IFACE2, ("[%s] IFACE: Connecting netflow (%s)", b->name, out?"out":"in"));
   
     /* Create global ng_netflow(4) node if not yet. */
     if (gNetflowNodeID == 0) {
-	if (NgFuncInitGlobalNetflow())
+	if (NgFuncInitGlobalNetflow()) {
+	    MUTEX_UNLOCK(gNgMutex);
 	    return(-1);
+	}
     }
 
     /* Connect ng_netflow(4) node to the ng_bpf(4)/ng_tee(4) node. */
@@ -2617,6 +2665,7 @@
 	sizeof(cn)) < 0) {
       Perror("[%s] can't connect \"%s\"->\"%s\" and \"%s\"->\"%s\"",
         b->name, path, cn.ourhook, cn.path, cn.peerhook);
+      MUTEX_UNLOCK(gNgMutex);
       return (-1);
     }
     strlcat(path, ".", NG_PATHSIZ);
@@ -2630,6 +2679,7 @@
 #ifndef NG_NETFLOW_CONF_INGRESS
     }
 #endif
+    MUTEX_UNLOCK(gNgMutex);
     return (0);
 }
 
@@ -2650,6 +2700,7 @@
     nif = gNetflowIface + b->id*2 + out;
 #endif
     
+    MUTEX_LOCK(gNgMutex);
     /* Configure data link type and interface index. */
     snprintf(path, sizeof(path), "[%x]:", gNetflowNodeID);
     nf_setdlt.iface = nif;
@@ -2685,8 +2736,10 @@
     }
 #endif
 
+    MUTEX_UNLOCK(gNgMutex);
     return 0;
 fail:
+    MUTEX_UNLOCK(gNgMutex);
     return -1;
 }
 
@@ -2703,11 +2756,13 @@
     nif = gNetflowIface + b->id*2 + out;
 #endif
 
+    MUTEX_LOCK(gNgMutex);
     snprintf(path, NG_PATHSIZ, "[%x]:", gNetflowNodeID);
     snprintf(hook, NG_HOOKSIZ, "%s%d", NG_NETFLOW_HOOK_DATA, nif);
     NgFuncDisconnect(gLinksCsock, b->name, path, hook);
     snprintf(hook, NG_HOOKSIZ, "%s%d", NG_NETFLOW_HOOK_OUT, nif);
     NgFuncDisconnect(gLinksCsock, b->name, path, hook);
+    MUTEX_UNLOCK(gNgMutex);
 }
 #endif
 
@@ -2721,6 +2776,7 @@
 	struct ngm_connect	cn;
 #endif
 
+        MUTEX_LOCK(gNgMutex);
 	Log(LG_IFACE2, ("[%s] IFACE: Connecting tcpmssfix", b->name));
   
 #ifdef USE_NG_TCPMSS
@@ -2793,8 +2849,10 @@
     }
 #endif /* USE_NG_TCPMSS */
 
+    MUTEX_UNLOCK(gNgMutex);
     return (0);
 fail:
+    MUTEX_UNLOCK(gNgMutex);
     return (-1);
 }
 
@@ -2811,6 +2869,7 @@
   struct	ng_tcpmss_config tcpmsscfg;
   char		path[NG_PATHSIZ];
 
+  MUTEX_LOCK(gNgMutex);
   snprintf(path, sizeof(path), "mpd%d-%s-mss:", gPid, b->name);
 
   /* Send configure message. */
@@ -2829,6 +2888,7 @@
       &tcpmsscfg, sizeof(tcpmsscfg)) < 0) {
     Perror("[%s] can't configure %s node program", b->name, NG_TCPMSS_NODE_TYPE);
   }
+  MUTEX_UNLOCK(gNgMutex);
 #else
     union {
 	u_char			buf[NG_BPF_HOOKPROG_SIZE(TCPSYN_PROG_LEN)];
@@ -2837,6 +2897,7 @@
     struct ng_bpf_hookprog	*const hp = &u.hprog;
     char			hook[NG_HOOKSIZ];
 
+    MUTEX_LOCK(gNgMutex);
     /* Setup programs for ng_bpf hooks */
     snprintf(hook, sizeof(hook), "i%d", b->id);
 
@@ -2889,6 +2950,7 @@
 	    NGM_BPF_SET_PROGRAM, hp, NG_BPF_HOOKPROG_SIZE(hp->bpf_prog_len)) < 0)
 	Perror("[%s] can't set %s node program", b->name, NG_BPF_NODE_TYPE);
 
+    MUTEX_UNLOCK(gNgMutex);
 #endif /* USE_NG_TCPMSS */
 }
 
@@ -2897,6 +2959,7 @@
 {
 	char	path[NG_PATHSIZ];
 
+        MUTEX_LOCK(gNgMutex);
 #ifdef USE_NG_TCPMSS
 	snprintf(path, sizeof(path), "mpd%d-%s-mss:", gPid, b->name);
 	NgFuncShutdownNode(gLinksCsock, b->name, path);
@@ -2904,6 +2967,7 @@
 	snprintf(path, sizeof(path), "i%d", b->id);
 	NgFuncShutdownNode(gLinksCsock, b->name, path);
 #endif
+        MUTEX_UNLOCK(gNgMutex);
 }
 #endif /* defined(USE_NG_TCPMSS) || (!defined(USE_NG_TCPMSS) && defined(USE_NG_BPF)) */
 
@@ -2914,6 +2978,7 @@
     struct ngm_mkpeer	mp;
     struct ngm_name	nm;
 
+    MUTEX_LOCK(gNgMutex);
     if (b->params.acl_limits[0] || b->params.acl_limits[1]) {
 
 	Log(LG_IFACE2, ("[%s] IFACE: Connecting limits", b->name));
@@ -2947,8 +3012,10 @@
 
     }
 
+    MUTEX_UNLOCK(gNgMutex);
     return (0);
 fail:
+    MUTEX_UNLOCK(gNgMutex);
     return (-1);
 }
 
@@ -3120,6 +3187,7 @@
 			sprintf(hp->ifMatch, "%d-%d-m", dir, num);
 			sprintf(inhookn[0], "%d-%d-mi", dir, num);
 
+		        MUTEX_LOCK(gNgMutex);
 			/* Connect nomatch hook to bpf itself. */
 			strcpy(cn.ourhook, hp->ifMatch);
 			strcpy(cn.path, path);
@@ -3130,6 +3198,7 @@
 			        b->name, path, cn.ourhook, cn.path, cn.peerhook);
 			}
 			strcpy(stathook, inhookn[0]);
+		        MUTEX_UNLOCK(gNgMutex);
 		    }
 		} else if (strcasecmp(av[p], "pass") == 0) {
 		    strcpy(hp->ifMatch, outhook);
@@ -3144,6 +3213,7 @@
 		    struct ng_car_bulkconf car;
 		    char		tmppath[NG_PATHSIZ];
 
+		    MUTEX_LOCK(gNgMutex);
 		    sprintf(hp->ifMatch, "%d-%d-m", dir, num);
 
 		    /* Create a car node for traffic shaping. */
@@ -3242,6 +3312,7 @@
 			sprintf(inhookn[0], "%d-%d-mi", dir, num);
 			strcpy(stathook, inhookn[0]);
 		    }
+		    MUTEX_UNLOCK(gNgMutex);
 #endif /* USE_NG_CAR */
 	        } else {
 		    Log(LG_ERR, ("[%s] IFACE: unknown action: '%s'",
@@ -3251,6 +3322,7 @@
 		
 		/* Prepare nomatch */
 		if (l->next && strcasecmp(av[0], "all")) {
+		    MUTEX_LOCK(gNgMutex);
 		    /* If there is next limit and there is possible nomatch,
 		     * then pass nomatch there. */
 		    sprintf(hp->ifNotMatch, "%d-%d-n", dir, num);
@@ -3265,6 +3337,7 @@
 			Perror("[%s] IFACE: can't connect \"%s\"->\"%s\" and \"%s\"->\"%s\"",
 			    b->name, path, cn.ourhook, cn.path, cn.peerhook);
 		    }
+		    MUTEX_UNLOCK(gNgMutex);
 		} else {
 		    /* There is no next limit, pass nomatch. */
 		    strcpy(hp->ifNotMatch, outhook);
@@ -3300,12 +3373,14 @@
 			    SLIST_INSERT_HEAD(&ss->src, sss, next);
 			}
 		
+		        MUTEX_LOCK(gNgMutex);
 		        strcpy(hp->thisHook, inhook[i]);
 		        if (NgSendMsg(gLinksCsock, path, NGM_BPF_COOKIE, NGM_BPF_SET_PROGRAM,
 		    		hp, NG_BPF_HOOKPROG_SIZE(hp->bpf_prog_len)) < 0) {
 			    Perror("[%s] IFACE: can't set %s node program",
 	    		        b->name, NG_BPF_NODE_TYPE);
 			}
+		        MUTEX_UNLOCK(gNgMutex);
 		    }
 		    strcpy(inhook[i], inhookn[i]);
 		}
@@ -3313,6 +3388,7 @@
 		num++;
 	    }
 	
+	    MUTEX_LOCK(gNgMutex);
 	    /* Connect left hooks to output */
 	    for (i = 0; i < 2; i++) {
 		if (inhook[i][0] != 0) {
@@ -3330,6 +3406,7 @@
 		    }
 		}
 	    }
+	    MUTEX_UNLOCK(gNgMutex);
 	}
     }
     Freee(hpu);
@@ -3352,8 +3429,10 @@
     }
 
     if (b->params.acl_limits[0] || b->params.acl_limits[1]) {
+        MUTEX_LOCK(gNgMutex);
 	snprintf(path, sizeof(path), "[%x]:", b->iface.limitID);
 	NgFuncShutdownNode(gLinksCsock, b->name, path);
+        MUTEX_UNLOCK(gNgMutex);
     }
 
     for (i = 0; i < ACL_DIRS; i++) {
@@ -3397,6 +3476,7 @@
 		SLIST_INSERT_HEAD(&stat->stat[dir], ssr, next);
 	    }
     
+	    MUTEX_LOCK(gNgMutex);
 	    SLIST_FOREACH(sss, &ss->src, next) {
 		if (NgSendMsg(gLinksCsock, path,
     		    NGM_BPF_COOKIE, NGM_BPF_GET_STATS, sss->hook, strlen(sss->hook)+1) < 0)
@@ -3423,6 +3503,7 @@
 		    break;
 		}
 	    }
+	    MUTEX_UNLOCK(gNgMutex);
 	}
     }
 }
diff -ur mpd-5.6/src/input.c mpd-5.6-lutz/src/input.c
--- mpd-5.6/src/input.c	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/input.c	2013-03-28 16:49:23.000000000 +0100
@@ -247,7 +247,9 @@
 		    Log(LG_ECHO, ("[%s] rec'd %s #%d, replying...",
 			b->name, FsmCodeName(hdr->code), hdr->id));
 		    MBDATAU(pkt)[0] = CODE_ECHOREP;
+		    MUTEX_LOCK(gNgMutex);
 		    NgFuncWritePppFrame(b, NG_PPP_BUNDLE_LINKNUM, PROTO_LCP, pkt);
+		    MUTEX_UNLOCK(gNgMutex);
 		    return;
 
 		case CODE_ECHOREP:
diff -ur mpd-5.6/src/ipcp.c mpd-5.6-lutz/src/ipcp.c
--- mpd-5.6/src/ipcp.c	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/ipcp.c	2013-04-24 12:20:07.000000000 +0200
@@ -246,11 +246,15 @@
   Printf("  %15s\r\n", inet_ntoa(ipcp->want_nbns[1]));
 
 #ifdef USE_NG_VJC
+  MUTEX_LOCK(gNgMutex);
   /* Get VJC state */
   snprintf(path, sizeof(path), "mpd%d-%s:%s", gPid, ctx->bund->name, NG_PPP_HOOK_VJC_IP);
   if (NgFuncSendQuery(path, NGM_VJC_COOKIE, NGM_VJC_GET_STATE,
-      NULL, 0, &u.reply, sizeof(u), NULL) < 0)
+      NULL, 0, &u.reply, sizeof(u), NULL) < 0) {
+    MUTEX_UNLOCK(gNgMutex);
     return(0);
+  }
+  MUTEX_UNLOCK(gNgMutex);
 
   Printf("VJ Compression:\r\n");
   Printf("\tOut comp : %d\r\n", sls->sls_compressed);
@@ -320,7 +324,7 @@
     /* Get allowed IP addresses from config and/or from current bundle */
     if (ipcp->conf.self_ippool[0]) {
 	if (IPPoolGet(ipcp->conf.self_ippool, &ipcp->self_allow.addr)) {
-	    Log(LG_IPCP, ("[%s] IPCP: Can't get IP from pool \"%s\" for self",
+	    Log(LG_ERR|LG_IPCP, ("[%s] IPCP: Can't get IP from pool \"%s\" for self",
 		b->name, ipcp->conf.self_ippool));
 	} else {
 	    Log(LG_IPCP, ("[%s] IPCP: Got IP %s from pool \"%s\" for self",
@@ -338,7 +342,7 @@
     else if (b->params.ippool[0]) {
 	/* Get IP from pool if needed */
 	if (IPPoolGet(b->params.ippool, &ipcp->peer_allow.addr)) {
-	    Log(LG_IPCP, ("[%s] IPCP: Can't get IP from pool \"%s\" for peer",
+	    Log(LG_ERR|LG_IPCP, ("[%s] IPCP: Can't get IP from pool \"%s\" for peer",
 		b->name, b->params.ippool));
 	} else {
 	    Log(LG_IPCP, ("[%s] IPCP: Got IP %s from pool \"%s\" for peer",
@@ -350,7 +354,7 @@
 	}
     } else if (ipcp->conf.ippool[0]) {
 	if (IPPoolGet(ipcp->conf.ippool, &ipcp->peer_allow.addr)) {
-	    Log(LG_IPCP, ("[%s] IPCP: Can't get IP from pool \"%s\"",
+	    Log(LG_ERR|LG_IPCP, ("[%s] IPCP: Can't get IP from pool \"%s\"",
 		b->name, ipcp->conf.ippool));
 	} else {
 	    Log(LG_IPCP, ("[%s] IPCP: Got IP %s from pool \"%s\" for peer",
@@ -545,10 +549,12 @@
 	vjc.maxChannel = ipcp->peer_comp.maxchan;
 	vjc.compressCID = ipcp->peer_comp.compcid;
         snprintf(path, sizeof(path), "[%x]:%s", b->nodeID, NG_PPP_HOOK_VJC_IP);
+	MUTEX_LOCK(gNgMutex);
 	if (NgSendMsg(gLinksCsock, path,
     		NGM_VJC_COOKIE, NGM_VJC_SET_CONFIG, &vjc, sizeof(vjc)) < 0) {
 	    Perror("[%s] can't config %s node", b->name, NG_VJC_NODE_TYPE);
 	}
+	MUTEX_UNLOCK(gNgMutex);
     }
 #endif /* USE_NG_VJC */
 
@@ -558,7 +564,9 @@
     b->pppConfig.bund.enableVJCompression = vjc.enableComp;
     b->pppConfig.bund.enableVJDecompression = vjc.enableDecomp;
 #endif
+    MUTEX_LOCK(gNgMutex);
     NgFuncSetConfig(b);
+    MUTEX_UNLOCK(gNgMutex);
 
     BundNcpsJoin(b, NCP_IPCP);
 }
@@ -585,7 +593,9 @@
     b->pppConfig.bund.enableVJCompression = 0;
     b->pppConfig.bund.enableVJDecompression = 0;
 #endif
+    MUTEX_LOCK(gNgMutex);
     NgFuncSetConfig(b);
+    MUTEX_UNLOCK(gNgMutex);
 
 #ifdef USE_NG_VJC
     if (ntohs(ipcp->peer_comp.proto) == PROTO_VJCOMP || 
@@ -905,6 +915,7 @@
   char path[NG_PATHSIZ];
   struct ngm_name	nm;
 
+  MUTEX_LOCK(gNgMutex);
   /* Add a VJ compression node */
   snprintf(path, sizeof(path), "[%x]:", b->nodeID);
   strcpy(mp.type, NG_VJC_NODE_TYPE);
@@ -954,8 +965,10 @@
     goto fail;
   }
 
+    MUTEX_UNLOCK(gNgMutex);
     return 0;
 fail:
+    MUTEX_UNLOCK(gNgMutex);
     return -1;
 }
 
@@ -964,8 +977,10 @@
 {
     char	path[NG_PATHSIZ];
 
+    MUTEX_LOCK(gNgMutex);
     snprintf(path, sizeof(path), "[%x]:%s", b->nodeID, NG_PPP_HOOK_VJC_IP);
     NgFuncShutdownNode(gLinksCsock, b->name, path);
+    MUTEX_UNLOCK(gNgMutex);
 }
 #endif /* USE_NG_VJC */
 
diff -ur mpd-5.6/src/ipv6cp.c mpd-5.6-lutz/src/ipv6cp.c
--- mpd-5.6/src/ipv6cp.c	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/ipv6cp.c	2013-03-28 16:48:56.000000000 +0100
@@ -300,7 +300,9 @@
 
     /* Enable IP packets in the PPP node */
     b->pppConfig.bund.enableIPv6 = 1;
+    MUTEX_LOCK(gNgMutex);
     NgFuncSetConfig(b);
+    MUTEX_UNLOCK(gNgMutex);
 
     BundNcpsJoin(b, NCP_IPV6CP);
 }
@@ -320,7 +322,9 @@
 
     /* Turn off IP packets */
     b->pppConfig.bund.enableIPv6 = 0;
+    MUTEX_LOCK(gNgMutex);
     NgFuncSetConfig(b);
+    MUTEX_UNLOCK(gNgMutex);
 }
 
 /*
diff -ur mpd-5.6/src/l2tp.c mpd-5.6-lutz/src/l2tp.c
--- mpd-5.6/src/l2tp.c	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/l2tp.c	2013-04-24 12:16:51.000000000 +0200
@@ -399,7 +399,7 @@
 
 	/* Sanity check. */
 	if (l->state != PHYS_STATE_DOWN) {
-		Log(LG_PHYS, ("[%s] L2TP: allready active", l->name));
+		Log(LG_ERR|LG_PHYS, ("[%s] L2TP: allready active", l->name));
 		return;
 	};
 
@@ -536,9 +536,11 @@
 	    tun->ctrl, u_addrtoa(&tun->self_addr,buf,sizeof(buf)), tun->self_port,
 	    u_addrtoa(&tun->peer_addr,buf2,sizeof(buf2)), tun->peer_port));
 
+	MUTEX_LOCK(gNgMutex);
 	/* Get a temporary netgraph socket node */
 	if (NgMkSockNode(NULL, &csock, &dsock) == -1) {
 	    Perror("[%s] NgMkSockNode", l->name);
+	    MUTEX_UNLOCK(gNgMutex);
 	    goto fail;
 	}
 
@@ -555,6 +557,7 @@
 	if (NgSendMsg(csock, namebuf, NGM_GENERIC_COOKIE,
 	    NGM_MKPEER, &mkpeer, sizeof(mkpeer)) == -1) {
 		Perror("[%s] mkpeer", l->name);
+		MUTEX_UNLOCK(gNgMutex);
 		goto fail;
 	}
 
@@ -569,12 +572,14 @@
 	if (NgSendMsg(csock, namebuf, NGM_KSOCKET_COOKIE,
 	    NGM_KSOCKET_SETOPT, sockopt, sizeof(sockopt_buf)) == -1) {
 		Perror("[%s] setsockopt", l->name);
+		MUTEX_UNLOCK(gNgMutex);
 		goto fail;
 	}
 	sockopt->name = SO_REUSEPORT;
 	if (NgSendMsg(csock, namebuf, NGM_KSOCKET_COOKIE,
 	    NGM_KSOCKET_SETOPT, sockopt, sizeof(sockopt_buf)) == -1) {
 		Perror("[%s] setsockopt", l->name);
+		MUTEX_UNLOCK(gNgMutex);
 		goto fail;
 	}
 
@@ -584,6 +589,7 @@
 	    if (NgSendMsg(csock, namebuf, NGM_KSOCKET_COOKIE,
 		NGM_KSOCKET_BIND, &sas, sas.ss_len) == -1) {
 		    Perror("[%s] bind", l->name);
+		    MUTEX_UNLOCK(gNgMutex);
 		    goto fail;
 	    }
 	}
@@ -593,6 +599,7 @@
 	      NGM_KSOCKET_CONNECT, &sas, sas.ss_len) == -1
 	    && errno != EINPROGRESS) {
 		Perror("[%s] connect", l->name);
+		MUTEX_UNLOCK(gNgMutex);
 		goto fail;
 	}
 
@@ -605,6 +612,7 @@
 	} else {
 	    sockaddrtou_addr(getsas,&tun->self_addr,&tun->self_port);
 	}
+	MUTEX_UNLOCK(gNgMutex);
 
 	/* Add peer to our hash table */
 	if (ghash_put(gL2tpTuns, tun) == -1) {
@@ -704,9 +712,11 @@
 	
 	if (node_id != 0) {
 
+	    MUTEX_LOCK(gNgMutex);
 	    /* Get a temporary netgraph socket node */
 	    if (NgMkSockNode(NULL, &csock, NULL) == -1) {
 		Perror("L2TP: NgMkSockNode");
+		MUTEX_UNLOCK(gNgMutex);
 		return;
 	    }
 	
@@ -715,6 +725,7 @@
 	    NgFuncDisconnect(csock, l->name, path, hook);
 	
 	    close(csock);
+	    MUTEX_UNLOCK(gNgMutex);
 	}
     }
 }
@@ -1194,7 +1205,7 @@
 		ppp_l2tp_avp_ptrs_destroy(&ptrs);
 		return;
 	}
-	Log(LG_PHYS, ("L2TP: No free link with requested parameters "
+	Log(LG_ERR|LG_PHYS, ("L2TP: No free link with requested parameters "
 	    "was found"));
 failed:
 	ppp_l2tp_terminate(sess, L2TP_RESULT_AVAIL_TEMP, 0, NULL);
@@ -1305,6 +1316,7 @@
 	char		path[NG_PATHSIZ];
 	struct ngm_connect      cn;
 
+	MUTEX_LOCK(gNgMutex);
 	/* Get a temporary netgraph socket node */
 	if (NgMkSockNode(NULL, &csock, NULL) == -1) {
 		Perror("L2TP: NgMkSockNode");
@@ -1319,7 +1331,7 @@
 
 	/* Connect our ng_ppp(4) node link hook and ng_l2tp(4) node. */
 	if (!PhysGetUpperHook(l, cn.path, cn.peerhook)) {
-	    Log(LG_PHYS, ("[%s] L2TP: can't get upper hook", l->name));
+	    Log(LG_ERR|LG_PHYS, ("[%s] L2TP: can't get upper hook", l->name));
 	    goto fail;
 	}
 	snprintf(path, sizeof(path), "[%lx]:", (u_long)node_id);
@@ -1330,11 +1342,13 @@
     		    l->name, path, cn.ourhook, cn.path, cn.peerhook);
 		goto fail;
 	}
+	MUTEX_UNLOCK(gNgMutex);
 	ppp_l2tp_sess_hooked(pi->sess);
 	close(csock);
 	return;
 
 fail:
+	MUTEX_UNLOCK(gNgMutex);
 	/* Clean up after failure */
 	ppp_l2tp_terminate(pi->sess, L2TP_RESULT_ERROR,
 	    L2TP_ERROR_GENERIC, strerror(errno));
@@ -1433,7 +1447,7 @@
 		}
 	}
 	if (pi == NULL) {
-		Log(LG_PHYS, ("L2TP: No link with requested parameters "
+		Log(LG_ERR|LG_PHYS, ("L2TP: No link with requested parameters "
 		    "was found"));
 		goto fail;
 	}
@@ -1472,9 +1486,11 @@
 	}
 	ppp_l2tp_ctrl_set_cookie(tun->ctrl, tun);
 
+	MUTEX_LOCK(gNgMutex);
 	/* Get a temporary netgraph socket node */
 	if (NgMkSockNode(NULL, &csock, &dsock) == -1) {
 		Perror("L2TP: NgMkSockNode");
+		MUTEX_UNLOCK(gNgMutex);
 		goto fail;
 	}
 
@@ -1487,12 +1503,14 @@
 	if (NgSendMsg(csock, ".:", NGM_GENERIC_COOKIE,
 	    NGM_CONNECT, &connect, sizeof(connect)) == -1) {
 		Perror("L2TP: connect");
+		MUTEX_UNLOCK(gNgMutex);
 		goto fail;
 	}
 
 	/* Write the received packet to the node */
 	if (NgSendData(dsock, hook, (u_char *)buf, len) == -1) {
 		Perror("L2TP: NgSendData");
+		MUTEX_UNLOCK(gNgMutex);
 		goto fail;
 	}
 
@@ -1502,6 +1520,7 @@
 	if (NgSendMsg(csock, ".:", NGM_GENERIC_COOKIE,
 	    NGM_RMHOOK, &rmhook, sizeof(rmhook)) == -1) {
 		Perror("L2TP: rmhook");
+		MUTEX_UNLOCK(gNgMutex);
 		goto fail;
 	}
 
@@ -1517,6 +1536,7 @@
 	if (NgSendMsg(csock, namebuf, NGM_GENERIC_COOKIE,
 	    NGM_MKPEER, &mkpeer, sizeof(mkpeer)) == -1) {
 		Perror("L2TP: mkpeer");
+		MUTEX_UNLOCK(gNgMutex);
 		goto fail;
 	}
 
@@ -1531,12 +1551,14 @@
 	if (NgSendMsg(csock, namebuf, NGM_KSOCKET_COOKIE,
 	    NGM_KSOCKET_SETOPT, sockopt, sizeof(sockopt_buf)) == -1) {
 		Perror("L2TP: setsockopt");
+		MUTEX_UNLOCK(gNgMutex);
 		goto fail;
 	}
 	sockopt->name = SO_REUSEPORT;
 	if (NgSendMsg(csock, namebuf, NGM_KSOCKET_COOKIE,
 	    NGM_KSOCKET_SETOPT, sockopt, sizeof(sockopt_buf)) == -1) {
 		Perror("L2TP: setsockopt");
+		MUTEX_UNLOCK(gNgMutex);
 		goto fail;
 	}
 
@@ -1545,6 +1567,7 @@
 	if (NgSendMsg(csock, namebuf, NGM_KSOCKET_COOKIE,
 	    NGM_KSOCKET_BIND, &sas, sas.ss_len) == -1) {
 		Perror("L2TP: bind");
+		MUTEX_UNLOCK(gNgMutex);
 		goto fail;
 	}
 
@@ -1553,8 +1576,10 @@
 	      NGM_KSOCKET_CONNECT, &peer_sas, peer_sas.ss_len) == -1
 	    && errno != EINPROGRESS) {
 		Perror("L2TP: connect");
+		MUTEX_UNLOCK(gNgMutex);
 		goto fail;
 	}
+	MUTEX_UNLOCK(gNgMutex);
 
 	/* Add peer to our hash table */
 	if (ghash_put(gL2tpTuns, tun) == -1) {
diff -ur mpd-5.6/src/l2tp_ctrl.c mpd-5.6-lutz/src/l2tp_ctrl.c
--- mpd-5.6/src/l2tp_ctrl.c	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/l2tp_ctrl.c	2013-04-24 12:13:56.000000000 +0200
@@ -476,6 +476,7 @@
 	/* Debugging */
 	Log(LOG_DEBUG, ("L2TP: %s invoked", __FUNCTION__));
 
+	MUTEX_LOCK(gNgMutex);
 	/* Select an unused, non-zero local tunnel ID */
 	while (ctrl->config.tunnel_id == 0
 	    || ghash_get(ppp_l2tp_ctrls, ctrl) != NULL)
@@ -594,6 +595,7 @@
 
 	ctrl->state = CS_IDLE;		/* wait for peer's sccrq */
 
+	MUTEX_UNLOCK(gNgMutex);
 	/* Expect some sort of reply */
 	ppp_l2tp_ctrl_check_reply(ctrl);
 
@@ -608,6 +610,7 @@
 		(void)close(ctrl->csock);	/* l2tp node will go away too */
 	if (ctrl->dsock >= 0)
 		(void)close(ctrl->dsock);
+	MUTEX_UNLOCK(gNgMutex);
 	pevent_unregister(&ctrl->reply_timer);
 	pevent_unregister(&ctrl->ctrl_event);
 	pevent_unregister(&ctrl->data_event);
@@ -1008,10 +1011,12 @@
 ppp_l2tp_sess_hooked(struct ppp_l2tp_sess *sess) {
 	char path[32];
 
+	MUTEX_LOCK(gNgMutex);
 	snprintf(path, sizeof(path), "[%lx]:", (u_long)sess->node_id);
 	(void)NgSendMsg(sess->ctrl->csock, path,
 	    NGM_GENERIC_COOKIE, NGM_SHUTDOWN, NULL, 0);
 	sess->node_id = 0;
+	MUTEX_UNLOCK(gNgMutex);
 }
 
 /************************************************************************
@@ -1057,10 +1062,14 @@
 
 	strlcpy(ctrl->peer_name, ptrs->hostname->hostname, sizeof(ctrl->peer_name));
 
+	MUTEX_LOCK(gNgMutex);
 	/* Update netgraph node configuration */
 	if (NgSendMsg(ctrl->csock, NG_L2TP_HOOK_CTRL, NGM_L2TP_COOKIE,
-	    NGM_L2TP_SET_CONFIG, &ctrl->config, sizeof(ctrl->config)) == -1)
+	    NGM_L2TP_SET_CONFIG, &ctrl->config, sizeof(ctrl->config)) == -1) {
+		MUTEX_UNLOCK(gNgMutex);
 		return (-1);
+	}
+	MUTEX_UNLOCK(gNgMutex);
 
 	/* See if there is a challenge AVP */
 	if (ptrs->challenge != NULL) {
@@ -1102,11 +1111,15 @@
 ppp_l2tp_ctrl_setup_2(struct ppp_l2tp_ctrl *ctrl,
 	struct ppp_l2tp_avp_ptrs *ptrs)
 {
+	MUTEX_LOCK(gNgMutex);
 	/* Peer now knows our tunnel ID */
 	ctrl->config.match_id = 1;
 	if (NgSendMsg(ctrl->csock, NG_L2TP_HOOK_CTRL, NGM_L2TP_COOKIE,
-	    NGM_L2TP_SET_CONFIG, &ctrl->config, sizeof(ctrl->config)) == -1)
+	    NGM_L2TP_SET_CONFIG, &ctrl->config, sizeof(ctrl->config)) == -1) {
+		MUTEX_UNLOCK(gNgMutex);
 		return (-1);
+	}
+	MUTEX_UNLOCK(gNgMutex);
 
 	/* Verify peer's challenge response */
 	if (ctrl->secret != NULL) {
@@ -1261,8 +1274,13 @@
 		ppp_l2tp_ctrl_dump(ctrl, avps, "L2TP: XMIT(0x%04x) ",
 		    ntohs(session_id));
 	}
-	if (NgSendData(ctrl->dsock, NG_L2TP_HOOK_CTRL, data, 2 + len) == -1)
+
+	MUTEX_LOCK(gNgMutex);
+	if (NgSendData(ctrl->dsock, NG_L2TP_HOOK_CTRL, data, 2 + len) == -1) {
+		MUTEX_UNLOCK(gNgMutex);
 		goto fail;
+	}
+	MUTEX_UNLOCK(gNgMutex);
 
 	/* Done */
 	goto done;
@@ -1527,6 +1545,7 @@
 	struct ngm_mkpeer mkpeer;
 	char path[64];
 
+	MUTEX_LOCK(gNgMutex);
 	/* If link side is waiting for confirmation, schedule it */
 	if (sess->side == SIDE_LNS || sess->orig == ORIG_LOCAL) {
 		pevent_unregister(&sess->notify_timer);
@@ -1572,11 +1591,13 @@
 		goto fail;
 	}
 
+	MUTEX_UNLOCK(gNgMutex);
 	/* Call is now established */
 	sess->state = SS_ESTABLISHED;
 	return (0);
 
 fail:
+	MUTEX_UNLOCK(gNgMutex);
 	/* Clean up after failure */
 	pevent_unregister(&sess->notify_timer);
 	return (-1);
@@ -1987,13 +2008,16 @@
 	struct ng_mesg *const msg = &buf.msg;
 	char raddr[NG_PATHSIZ];
 
+	MUTEX_LOCK(gNgMutex);
 	/* Read netgraph control message */
 	if (NgRecvMsg(ctrl->csock, msg, sizeof(buf), raddr) < 0) {
 		Perror("L2TP: error reading control message");
+		MUTEX_UNLOCK(gNgMutex);
 		ppp_l2tp_ctrl_close(ctrl, L2TP_RESULT_ERROR,
 		    L2TP_ERROR_GENERIC, strerror(errno));
 		return;
 	}
+	MUTEX_UNLOCK(gNgMutex);
 
 	/* Examine message */
 	switch (msg->header.typecookie) {
@@ -2398,9 +2422,11 @@
 		ppp_l2tp_sess_destroy(&sess);
 	}
 
+	MUTEX_LOCK(gNgMutex);
 	/* Destroy netgraph node */
 	(void)NgSendMsg(ctrl->csock, NG_L2TP_HOOK_CTRL,
 	    NGM_GENERIC_COOKIE, NGM_SHUTDOWN, NULL, 0);
+	MUTEX_UNLOCK(gNgMutex);
 
 	/* Destroy control connection */
 	ghash_remove(ppp_l2tp_ctrls, ctrl);
@@ -2454,8 +2480,10 @@
 	}
 	ghash_remove(ctrl->sessions, sess);
 	snprintf(path, sizeof(path), "[%lx]:", (u_long)sess->node_id);
+	MUTEX_LOCK(gNgMutex);
 	(void)NgSendMsg(ctrl->csock, path,
 	    NGM_GENERIC_COOKIE, NGM_SHUTDOWN, NULL, 0);
+	MUTEX_UNLOCK(gNgMutex);
 	ppp_l2tp_avp_list_destroy(&sess->my_avps);
 	ppp_l2tp_avp_list_destroy(&sess->peer_avps);
 	pevent_unregister(&sess->notify_timer);
